#define RFM69_TIMEOUTVAL    8000000UL

#include "global.h"



//#define DEBUG_RX
//#define DEBUG_TX


// Turn Receiver on and off
void switchToRecive(void) {
  //uint32_t utimer = RFM69_TIMEOUTVAL;

	//sendSingleMode(0x3D,(sendSingleMode(0x3D,0xFF, 0) | 0x04), 1);
	sendSingleMode(0x01,0x10, 1); // RX on (set to receiver mode in RegOpMode)

  #ifdef DEBUG_RX
	uartSendString("\r\nSW 2 RECIVE: ");
	print_hexXX(sendSingleMode(0x27,0x00, 0));
	print_hexXX(sendSingleMode(0x28,0x00, 0));
	#endif
	//while (--utimer && !(sendSingleMode(0x27,0x00, 0) & (1 << 6))){

	while (!(sendSingleMode(0x27,0x00, 0) & (1 << 6)) && //RX Ready
         !(sendSingleMode(0x27,0x00, 0) & (1 << 4)) && //Pll Lock
         !(sendSingleMode(0x27,0x00, 0) & (1 << 3))){  //Rssi

    #ifdef DEBUG_RX
    print_hexXX(sendSingleMode(0x27,0x00, 0));
    print_hexXX(sendSingleMode(0x28,0x00, 0));
    uartSendChar('|');
    #endif
	} // Wait for Mode-Ready--Flag
}

void switchToTransmit(void) {
	sendSingleMode(0x01,0x0C, 1); // RX on (set to receiver mode in RegOpMode)
	while (!(sendSingleMode(0x27,0x00, 0) & (1 << 7))); // Wait for Mode-Ready--Flag
}

void switchToStandby(void) {

	sendSingleMode(0x01,0x04, 1); // RX on (set to receiver mode in RegOpMode)

	uartSendChar('c');
	while (!(sendSingleMode(0x27,0x00, 0) & (1 << 7))){printReg(0x27);}; // Wait for Mode-Ready--Flag
	uartSendChar('d');
}

void recive(char* data,uint8_t max_length){

  uint8_t length;



  #ifdef DEBUG_RX
    uartSendString("\r\nRECIVE vor standby : ");
    print_hexXX(sendSingleMode(0x27,0xFF, 0));
    print_hexXX(sendSingleMode(0x28,0xFF, 0));
  #endif

    checkRxTimeout();

  #ifdef DEBUG_RX
    uartSendString("\r\nRECIVE nach TimeOut : ");
    print_hexXX(sendSingleMode(0x27,0xFF, 0));
    print_hexXX(sendSingleMode(0x28,0xFF, 0));
  #endif

  //switchToStandby(); // Turn off receiver, switch to Standby

  #ifdef DEBUG_RX
    uartSendString("\r\nRECIVE nacm standby : ");
    print_hexXX(sendSingleMode(0x27,0xFF, 0));
    print_hexXX(sendSingleMode(0x28,0xFF, 0));
  #endif

   // Read FIFO-data into FIFO-array
    if(sendSingleMode(0x28,0x00, 0) & (1 << 6)){
      enableSpi();
      spiTransferData(0x00); // Read-access register 0
      length = spiTransferData(0xFF);

      #ifdef DEBUG_RX
        int8_t buffer[4];
        itoa(length,buffer,10);
        uartSendString("\nLenght: ");
        uartSendString(buffer);
      #endif // DEBUG_RX

      if (max_length >= length){
        for (uint8_t i = 0; i < length; i++) {
          data[i] = spiTransferData(0xFF);
        }
        disableSpi();
      }else{
        length = 0;
      }
    }else{
      length = 0;
    }

	data[length] = '\0'; // Terminate string

	sendSingleMode(0x28,0x10, 1); //clear FIFO

	switchToStandby(); // Turn off receiver, switch to Standby

	#ifdef DEBUG_RX
    uartSendString("\r\n");
    uartSendString("RECIVE nach FIFO : ");
    print_hexXX(sendSingleMode(0x27,0xFF, 0));
    print_hexXX(sendSingleMode(0x28,0xFF, 0));
  #endif

}

void transmit(char* data,uint8_t length){


	 //switchToStandby(); // Turn off receiver, switch to Standby
  switchToStandby();

  sendSingleMode(0x28,0x10, 1); //clear FIFO


   // Read FIFO-data into FIFO-array
  enableSpi();
  spiTransferData(0x80); // Write-access register 0
  spiTransferData(length); // Write-access register 0

	for (uint8_t i = 0; i <= length; i++) {
		spiTransferData(data[i]);
	}

	disableSpi();

	#ifdef DEBUG_TX
    uartSendString("\r\n");
    uartSendString("TRANSMIT Nach Schreiben FIFO: ");
    print_hexXX(sendSingleMode(0x27,0xFF, 0));
    print_hexXX(sendSingleMode(0x28,0xFF, 0));
  #endif


  // Turn on transmitter (Transmitting starts automatically if FIFO not empty)
	 switchToTransmit();


  // Wait for Package Sent
	while (!(sendSingleMode(0x28,0xFF, 0) & (1 << 3))){
    #ifdef DEBUG_TX
      uartSendString("\r\n");
      uartSendString("Wait: ");
      print_hexXX(sendSingleMode(0x27,0xFF, 0));
      print_hexXX(sendSingleMode(0x28,0xFF, 0));
    #endif
	}

	#ifdef DEBUG_TX
    uartSendString("\r\n");
    uartSendString("TRANSMIT Nach WAIT-Schleife: ");
    print_hexXX(sendSingleMode(0x27,0xFF, 0));
    print_hexXX(sendSingleMode(0x28,0xFF, 0));
  #endif

	switchToStandby();
}

char sendSingleMode(char byte1, char byte2, char write){
  char result;

  if (write == 1){
    byte1 = byte1 | 0x80;
  }
  else{
    byte1 = byte1 & 0x7F;
    byte2 = 0x00;
  }

  enableSpi();
  spiTransferData(byte1);
  result = spiTransferData(byte2);
  disableSpi();

  return result;
}

void initRfm69(void){



  for(uint8_t i = 0 ; i < 10; i++){
  //Bitrate 4800kb/S
  longDelay(50);
  uartSendChar('a');
  sendSingleMode(0x02,0x00, 1); // FSK, Packet mode, No shaping
  uartSendChar('z');

  sendSingleMode(0x03,0x0D, 1);
  sendSingleMode(0x04,0x0D, 1);
  uartSendChar('z');

  //frequency deviation 45kHz --> deutsch Hub
  sendSingleMode(0x05,0x02, 1);
  sendSingleMode(0x06,0xE1, 1);
  uartSendChar('z');

  //Frequency = 433 MHZ --> 433000000 / 61 (FSTEP)

  //sendSingleMode(0x07,0x6C, 1);
  //sendSingleMode(0x08,0x40, 1);
  //sendSingleMode(0x09,0x00, 1);

 //Frequency = 868 MHZ --> 868000000 / 61 (FSTEP)

  sendSingleMode(0x07,0xD9, 1);
  sendSingleMode(0x08,0x00, 1);
  sendSingleMode(0x09,0x00, 1);
  uartSendChar('z');

  // Set Output Power +13db
  sendSingleMode(0x11,0x9D, 1);

  // Over current protection enabled, 100mA
  sendSingleMode(0x13,0x1B, 1);

  //LNA impedance
  sendSingleMode(0x18,0x00, 1); // LNA: 50 Ohm Input Impedance, Automatic Gain Control


  //RX Bandwidth and canceling
  sendSingleMode(0x19,0x43, 1); //DC cacelation 4%, RXBW = 62,5kHz

  //Auto Frequency correction Bandwidth and canceling
  sendSingleMode(0x1A,0x42, 1);

  // Auto frequency correction auto on and clear
  sendSingleMode(0x1E,0x2D, 1);


  // DIO-Mapping
  sendSingleMode(0x25,0x00, 1); // Clkout, FifoFull, FifoNotEmpty, FifoLevel, PacketSent/CrcOk
  sendSingleMode(0x26,0x07, 1); // Clock-Out off



  sendSingleMode(0x29,0xC4, 1); // RSSI mind. -98 dBm
  sendSingleMode(0x2A,0x00, 1); // No Timeout after Rx-Start if no RSSI-Interrupt occurs
  sendSingleMode(0x2B,0x28, 1); // Timeout after RSSI-Interrupt if no Payload-Ready-Interrupt occurs

  // Preamble length 4 bytes
  sendSingleMode(0x2C,0x00, 1);
  sendSingleMode(0x2D,0x04, 1);

  // Sync-Mode
  sendSingleMode(0x2E,0x88, 1); // set FIFO mode
  sendSingleMode(0x2F,0x2D, 1); // sync word 1 byte
  sendSingleMode(0x30,0xd4, 1); // sync word 2 byte
  sendSingleMode(0x31,0x00, 1); // sync word 3 byte
  sendSingleMode(0x32,0x00, 1); // sync word 4 byte
  sendSingleMode(0x33,0x00, 1); // sync word 5 byte
  sendSingleMode(0x34,0x00, 1); // sync word 6 byte
  sendSingleMode(0x35,0x00, 1); // sync word 7 byte
  sendSingleMode(0x36,0x00, 1); // sync word 8 byte

  // Packet config
  sendSingleMode(0x37,0x90, 1); // fix length, Manchester, CRC-Check, No CRCAutoClean , No Address filter
  sendSingleMode(0x38,0x1E, 1); // Max. Payload-Length
  sendSingleMode(0x3C,0x80, 1); // Tx-Start-Condition: FIFO not empty
  sendSingleMode(0x3D,0xA0, 1); // Packet-Config2


  // Receiver config
  sendSingleMode(0x58,0x2D, 1); // High sensitivity mode
  sendSingleMode(0x6F,0x30, 1); // Improved DAGC
  }

	// Start RC-Oscillator
	//sendSingleMode(0x0A,0x80, 1);

	// Wait for RC-Oscillator
  //uint32_t  utimer = RFM69_TIMEOUTVAL;
	//while (!(sendSingleMode(0x0A,0x00, 0) & (1 << 6)) && --utimer){
	//while (!(sendSingleMode(0x0A,0x00, 0) & (1 << 6))){
    //printReg(0x0A);
	//}
  uartSendChar('b');
	//switchToStandby();
	uartSendChar('c');
	//switchToRecive();
}

void checkRxTimeout(void){

	// No Payload and RSSI-Rx-Timeout -> Rx-Restart
	if (sendSingleMode(0x27,0x00,0) & (1 << 2) && sendSingleMode(0x28,0x00,0) & (1 << 2)) {
		sendSingleMode(0x3D, sendSingleMode(0x3D,0xFF,0) | 0x04 , 1);
	}
}

