#include "global.h"
#include <avr/io.h>





void uartInit(void){
  UBRR0H = UBRR_VAL >> 8;
  UBRR0L = UBRR_VAL & 0xFF;

  UCSR0B |= (1<<TXEN0)|(1<<RXEN0)|(1<<RXCIE0);  // UART TX und RX einschalten; Interrupt ausloesen wenn Signal kommt
//  UCSR0C = (1<<URSEL0)|(1<<UCSZ1)|(1<<UCSZ0);  // Asynchron 8N1
}

void uartSendChar(char c){
    while (!(UCSR0A & (1<<UDRE0)));  /* warten bis Senden moeglich*/
    UDR0 = c;
}


void uartSendString(char *s){
  uint16_t i = 0;
  while(s[i] != '\0'){
    uartSendChar(s[i]);
    i++;
  }
}


uint8_t uartReadChar(void){
    while (!(UCSR0A & (1<<RXC0)));   // warten bis Zeichen verfuegbar        ;
    return UDR0;                   // Zeichen aus UDR an Aufrufer zurueckgeben
}

/*
ISR(USART_RXC_vect){

    if (uartStatus == 1 || uartStatus == 2){
      dataFromGps[bytesRead++] = UDR;   //Read Data from GPS
    }
}
*/



